# Calling the Hamiltonian Fast Marching library from Python

The HamiltonFastMarching code can be used from Python in two ways:

1. using the executable FileHFM, which has no external dependencies

2. using the library PythonHFM, compiled with boost-numpy (Experimental)

The two methods provide similar functionality.
Option 1. is easier to compile, whereas 2. offers faster input/output.

We *strongy encourage* option 1, as we plan to deprecate option 2 in the future (dropping boost-numpy in favor of pybind11).

For option 1, change directory to ../FileHFM, and compile using CMake.

### Compilation instructions for 2 (boost-numpy, experimental)

In CMake, one needs to select the link with the same Python library as Boost.
See the discussion in http://stackoverflow.com/a/21052641

For me this is achieved by setting in CMake the following key:
PYTHON_LIBRARY =
/usr/local/Cellar/python/2.7.13/Frameworks/Python.framework/Versions/2.7/lib/libpython2.7.dylib

Important : Be careful to use the same version of python (2 or 3) for compiling the library and executing the scripts.
Failing to do results in the following error message (if compiling with python2 and executing scripts with python3)
ImportError: dynamic module does not define module export function (PyInit_PythonHFM_Isotropic2)

--------- Remarks on linking with python3 on Apple -------
By default, boost-python links with python2, and the python refers to python2, on this platform.
I have not tested python3 linking, but would be happy to now if anyone succeeds.
Starting point:
brew uninstall --force boost-python
brew install boost-python --with-python3 --without-python
