# Hamiltonian Fast Marching
## A Fast-Marching solver with adaptive stencils.

This archive contains is part of a submission to the [Image Processing On Line](http://www.ipol.im) journal.  
Jean-Marie Mirebeau, Jorg M. Portegies, Hamiltonian Fast Marching: A numerical solver for anisotropic and non-holonomic eikonal PDEs, 2019, accepted for publication.


It was validated as reproducible research, and supplemented with an online [demo](http://ipol-geometry.loria.fr/demo/227).  
Python(R) and Mathematica(R) notebooks are also provided alongside this publication.

## Code organization

The code is organized in two directories:
 - the HamiltonFastMarching-master subdirectory contains the main code, written in C++, to be compiled. Installation instructions are provided in the Readme.md file at the root of that directory.
 - the C++ library is meant to be called from a scripting language, such as Python(R), Mathematica(R), or Matlab(R).
 Illustrative examples can be found in the HamiltonFastMarching-master/Interfaces subdirectory.
 - the JMM_CPPLibs-master subdirectory contains a header only C++ library, that is required to compile the HamiltonFastMarching code.
 - the HFM_Python_Notebooks-master contains the jupyter notebooks.

## Latest version

The provided source code is part of an ongoing research project, that will continue to evolve. The latest version can be found is available on the Github repository [HamiltonFastMarching](https://github.com/Mirebeau/HamiltonFastMarching). See also the illustrating [notebooks](http://nbviewer.jupyter.org/urls/rawgithub.com/Mirebeau/HFM_Python_Notebooks/master/Summary.ipynb).

No backward compatibility is guaranteed.

## TL-DR. Simple and direct instructions (tested on macOs 10.14)

 * *Compiling the source code.*  
 Extract the archive *HFM-master-submitted* containing the source codes, distributed along the IPOL submission. In a terminal, change directory to root of the extracted archive, and type the following commands.
 ```console
 mkdir bin
 cd bin
 cmake ../HamiltonFastMarching-master/Interfaces/FileHFM
 make
 ```
 * *Viewing the python notebooks*  
  Download and install [anaconda](https://www.anaconda.com) or [miniconda](https://conda.io/en/latest/miniconda.html).  
  The notebooks are given in the  *HFM_Python_Notebooks-master* directory. In a terminal, change directory to root of the extracted archive, and type the following commands.
  ```console
  conda env create --file hfm-jupyter-mayavi.yaml
  source activate hfm-jupyter-mayavi
  jupyter notebook
  ```
